<?php
ini_set('max_execution_time', 600); //600 seconds = 10 minutes
ini_set('memory_limit', '250M');
ini_set('short_open_tag', 1);

$GLOBALS['settings_folder']=__DIR__.'/settings/';
$GLOBALS['temp_folder']=__DIR__.'/tempdata/';
@$GLOBALS['useragent']=file_get_contents($GLOBALS['temp_folder'].'useragent.txt');
$GLOBALS['cookie_file']=$GLOBALS['temp_folder'].'cookie.txt';
$GLOBALS['xsrftoken_file']=$GLOBALS['temp_folder'].'xsrftoken.txt';
@$GLOBALS['pub_id']=file_get_contents($GLOBALS['temp_folder'].'pub_id.txt');
$GLOBALS['m_useragent']='Mozilla/5.0 (Linux; Android 4.4.4; ru-ru; SAMSUNG GT-I9300I Build/KTU84P) AppleWebKit/537.36 (KHTML, like Gecko) Version/1.5 Chrome/28.0.1500.94 Mobile Safari/537.36';
$GLOBALS['creative_review_req_string']='https://www.google.com/adsense/gp/creativeReview?ov=3&pid='.$GLOBALS['pub_id'].'&authuser=0&tpid='.$GLOBALS['pub_id'];
$GLOBALS['arc_tab_req_string']='https://www.google.com/adsense/new/u/0/'.$GLOBALS['pub_id'].'/main/allowAndBlockAds?webPropertyCode=ca-'.$GLOBALS['pub_id'].'&tab=arcTab';
$GLOBALS['new_arc_tab_req_string']='https://www.google.com/adsense/new/u/0/'.$GLOBALS['pub_id'].'/arc/ca-'.$GLOBALS['pub_id'];
$GLOBALS['myheaders']=array('accept-language:en-US;q=1,en;q=0.4', 'content-type:application/javascript; charset=UTF-8');
$GLOBALS['myheaders_new']=array('accept-language:en-US;q=1,en;q=0.4', 'content-type:application/json;charset=UTF-8');
$GLOBALS['creative_review_new_string']='/ads-publisher-controls/acx/5/proto/creativereview/';


if(!file_exists($GLOBALS['settings_folder']) || !is_writeable($GLOBALS['settings_folder']))	{
    die('Check '.$GLOBALS['settings_folder'].' directory write permissions');
}

if(!file_exists($GLOBALS['temp_folder']) || !is_writeable($GLOBALS['temp_folder']))	{
    die('Check '.$GLOBALS['temp_folder'].' directory write permissions');
}

if(!file_exists($GLOBALS['temp_folder'].'logs'))
   mkdir($GLOBALS['temp_folder'].'logs', 0775);

if(!file_exists($GLOBALS['temp_folder'].'autoblocked_accs'))
   mkdir($GLOBALS['temp_folder'].'autoblocked_accs', 0775);




//if(php_sapi_name()!='cli')
if(empty($argc))
if(file_exists($GLOBALS['temp_folder'].'pass'))
if(file_get_contents($GLOBALS['temp_folder'].'pass')!='')
if(!isset($_COOKIE['key'])||$_COOKIE['key']!=file_get_contents($GLOBALS['temp_folder'].'auth_key')) {  //Autentification if password not empty
	header("Location: auth.php");
	exit;
}


if(file_exists($GLOBALS['settings_folder'].'settings.ini')) {
	$set=file_get_contents($GLOBALS['settings_folder'].'settings.ini');
	$set=json_decode($set, 1);
} else {
	$set['num_of_pages']=1;
	$set['num_of_ads_per_page']=30;
	$set['text']='checked';
	$set['stopwords_check']='checked';
	$set['mark_reviewed']='checked';
	$set['get_stats']='checked';
}

if(isset($set['log'])){
	ini_set('error_reporting', E_ALL);
	ini_set('display_errors', 1);
	ini_set('display_startup_errors', 1);
} else {
	ini_set('error_reporting', 0);
	ini_set('display_errors', 0);
	ini_set('display_startup_errors', 0);
}

$GLOBALS['set_gl']=$set;
$nl='
';

/**
— **
**/


function is_data_safely($input_data) {
	$ret=true;
	if(strpos($input_data, "<?")!==false) $ret=false;
	if(strpos($input_data, "?>")!==false) $ret=false;
	if(strpos($input_data, "strtolower")!==false) $ret=false;
	if(strpos($input_data, "strtoupper")!==false) $ret=false;
	if(strpos($input_data, "{")!==false) $ret=false;
	if(strpos($input_data, "}")!==false) $ret=false;
	if(strpos($input_data, "$")!==false) $ret=false;
	if(strpos($input_data, "strip")!==false) $ret=false;
	if(strpos($input_data, "decode")!==false) $ret=false;
	if(strpos($input_data, "eval")!==false) $ret=false;
	if(strpos($input_data, "chr")!==false) $ret=false;
	if(strpos($input_data, "./")!==false) $ret=false;
	return	$ret;
}



/**
 **
**/


function metagwt2array ($metahtml) {
	$dom = new DOMDocument('1.0', 'UTF-8');
	@$dom->loadHTML($metahtml);
	foreach ($dom->getElementsByTagName('meta') as $meta_node) {
		$list=explode('=', $meta_node->getAttribute('content'));
		$name=$list[0];
		$value=$list[1];
		unset($list);
		$name=str_replace('.', '_', $name);
		$gwtarray[$name]=$value;
	}
	unset($dom);
	return $gwtarray;
}


/**
 **
**/


function hex_repl($str) {
	$i=256;
	while($i>=0) {
		$hex=dechex($i);
		$str=str_ireplace("\x$hex", chr($i), $str);
		$i--;
	}
	return $str;
}


/**
 **
**/


function get_url_from_text_ad ($html) {

	$list=explode('buildAdSlot(', $html, 2);
	$script_with=$list[1];
		unset($list);
	$list=explode(');</script>', $script_with, 2);
	$script_with=$list[0];
		unset($list);
	$array=json_decode($script_with, 1);
		unset($script_with);
	$url=str_replace('\u0026', '&', $array[0][0][4]);
		unset($array);
	return $url;
}


/**
 **
**/


function get_2level_domain ($url) {
	$url=parse_url($url);
	$domain=explode('.', $url['host']);
	$last_index=count($domain)-1;
	$level2domain=$domain[$last_index-1].'.'.$domain[$last_index];
	unset($url,$domain,$last_index);
	$list=explode('.', $level2domain);
	return $list[0];
}



/**
 **
**/


function count_redirects($url) {

$domains[]=mb_strtolower( get_2level_domain($url), 'UTF-8' );

$myheaders = array('Accept:text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
'accept-language:en-US;q=0.6,en;q=0.4',
'content-type:application/javascript; charset=UTF-8',
'Cache-Control:max-age=0',
'Connection:keep-alive',
'Host:'.$domains[0],);

$nl='
';

$result = curl_get_headers($url, 'http://www.googleadservices.com/', $myheaders);
var_dump($result);
$result=explode($nl, $result);

foreach ($result as $string) {
	if(stripos($string, 'Location')!==false)
		if(stripos($string, ': /')===false)		 //Some location headers do not include any domain names
		if(stripos($string, 'Content-Location')===false) {
			$url=str_ireplace('Location:', '', $string);
			$url=trim($url);
			$domain=mb_strtolower( get_2level_domain($url), 'UTF-8' );
			if(trim($domain)) $domains[]=$domain;
	}
}

unset($result,$myheaders,$url);
/*
$count=0;
foreach ($domains as $index => $domain) {
	if($index) {
		if($domains[$index-1]!=$domain)
			$count++;
	}
}*/
$found=false;
$count=(count($domains));
if($count>1) {
	if($domains[0]!=$domains[($count-1)]) {
		$found=true;
	}
}

unset($domains);
return $found;
}


/**
 **
**/


function curl_get_headers($url, $referer, $myheaders) {

$ch = curl_init();
curl_setopt ($ch, CURLOPT_URL, $url);
curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt ($ch, CURLOPT_COOKIESESSION, 1);
curl_setopt ($ch, CURLOPT_HEADER, 1);
curl_setopt ($ch, CURLOPT_NOBODY, 1);
curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
if($myheaders) curl_setopt ($ch, CURLOPT_HTTPHEADER, $myheaders);
curl_setopt ($ch, CURLOPT_ENCODING, 'gzip,deflate');
curl_setopt ($ch, CURLOPT_USERAGENT, $GLOBALS['m_useragent']);
if($referer) curl_setopt ($ch, CURLOPT_REFERER, $referer);
$result = curl_exec($ch);
curl_close($ch);

return $result;
}


/**
 **
**/


function find_disguised_latin ($ad) {

$text=trim($ad['header1']);
if(isset($ad['header2'])) $text.=' '.trim($ad['header2']);
$text.=' '.trim($ad['body']);

$to_replace=array('-', ':', ';', '{', '}', '(', ')', ',', '%', '"', '+', '–', '&', '.', '/', '\\');
$text=str_replace($to_replace, ' ', $text);
$text=str_replace('   ', ' ', $text);
$text=str_replace('  ', ' ', $text);

$words=explode(' ', $text);
unset($text);
$found=0;
foreach ($words as $word) {
	if(preg_match('/([а-яёА-ЯЁ]{1,})\w*([а-яёА-ЯЁ]{1,})/u', $word))
		if(mb_strlen($word)>3)
			if(!preg_match('/(\d{1,})\w*(\d{1,})/u', $word))
				if(preg_match('/[aceonpxuyABCEHKMOPTXY]/u', $word))
					if(!preg_match('/[a-z]{4,}/u', $word)) {
						if(preg_match('/^[c]{1}/iu', $word))
							if(!preg_match('/[aceonpxuyABCEHKMOPTXY]/u', substr($word, 1)))
								continue;
						$found=$word;
						break;
					}
}
return $found;
}


/**
 **
**/

function lat_replace ($text) {

$lat=array('a', 'c', 'e', 'o', 'n', 'p', 'x', 'u', 'y',		'b', 'h', 'k', 'm', 't',	'à', 'á', 'â', 'ã', 'ä', 'å', 'ā', 'ă', 'ą', 'ò', 'ó', 'ô', 'õ', 'ö', 'ć', 'ĉ', 'ċ', 'č', 'ē', 'ĕ', 'ė', 'ę', 'ě', 'è', 'é', 'ê');
$cyr=array('а', 'с', 'е', 'о', 'п', 'р', 'х', 'и', 'у',		'в', 'н', 'к', 'м', 'т',	'а', 'а', 'а', 'а', 'а', 'а', 'а', 'а', 'а', 'о', 'о', 'о', 'о', 'о', 'с', 'с', 'с', 'с', 'е', 'е', 'е', 'е', 'е', 'е', 'е', 'е');

$text=str_replace($lat, $cyr, $text);

return $text;
}


/**
 **
**/


function curl_post($url, $postfields, $referer, $myheaders) {

$ch = curl_init();
curl_setopt ($ch, CURLOPT_URL, $url);
curl_setopt ($ch, CURLOPT_POST, 1);
curl_setopt ($ch, CURLOPT_POSTFIELDS, $postfields);
curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt ($ch, CURLOPT_COOKIESESSION, 1);
curl_setopt ($ch, CURLOPT_HEADER, 0);
curl_setopt ($ch, CURLOPT_ENCODING, 'gzip,deflate');
if($myheaders) curl_setopt ($ch, CURLOPT_HTTPHEADER, $myheaders);
curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt ($ch, CURLOPT_USERAGENT, $GLOBALS['useragent']);
curl_setopt ($ch, CURLOPT_COOKIEJAR, $GLOBALS['cookie_file']);
curl_setopt ($ch, CURLOPT_COOKIEFILE, $GLOBALS['cookie_file']);
curl_setopt ($ch, CURLOPT_REFERER, $referer);

$result = curl_exec($ch);
curl_close($ch);

unset($myheaders,$url,$postfields,$referer);

return $result;
}


/**
 **
**/


function curl_get($url, $referer, $myheaders) {

$ch = curl_init();
curl_setopt ($ch, CURLOPT_URL, $url);
curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt ($ch, CURLOPT_COOKIESESSION, 1);
curl_setopt ($ch, CURLOPT_HEADER, 0);
curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
if($myheaders) curl_setopt ($ch, CURLOPT_HTTPHEADER, $myheaders);
curl_setopt ($ch, CURLOPT_ENCODING, 'gzip,deflate');
curl_setopt ($ch, CURLOPT_USERAGENT, $GLOBALS['useragent']);
curl_setopt ($ch, CURLOPT_COOKIEJAR, $GLOBALS['cookie_file']);
curl_setopt ($ch, CURLOPT_COOKIEFILE, $GLOBALS['cookie_file']);
if($referer) curl_setopt ($ch, CURLOPT_REFERER, $referer);
$result = curl_exec($ch);
curl_close($ch);

return $result;
}

/**
 **
**/


function get_ad ($url) {

$ad_html=curl_get($url, $GLOBALS['arc_tab_req_string'], '');
if($ad_html) {
	$ad_html=hex_repl($ad_html);

	if(isset($GLOBALS['set_gl']['log'])) file_put_contents($GLOBALS['temp_folder'].'logs/ad.'.time().rand(0,10), $ad_html);

	if(mb_stripos($ad_html, 'class="rhbackground"')!==false) {				// File size about 143 Kb

		$ad=text_ad($ad_html);
		$ad['type']='text';

	} elseif(mb_stripos($ad_html, '<script>var serverAdData')!==false) {	// File size about 205 Kb

		$ad=multiformat_ad($ad_html);
		$ad['type']='Multi-format';

	} elseif(mb_stripos($ad_html, '<script>var adData')!==false) {			// File size about 174 Kb

		$ad=html5_1_ad($ad_html);
		$ad['type']='HTML5_1';

	} elseif(mb_stripos($ad_html, 'data-rh-set-type="26"')!==false || mb_stripos($ad_html, 'data-rh-set-type="25"')!==false) {  // File size about 156 Kb

		$ad=multimedia_ad25_26($ad_html);
		$ad['type']='Multimedia 2';

	} elseif(mb_stripos($ad_html, 'data-rh-set-type="15"')!==false) {  		// File size about 156 Kb

		$ad=multimedia_ad15($ad_html);
		$ad['type']='Multimedia 1';

	} elseif(mb_stripos($ad_html, '<html>')===false) {						// File size about 124 Kb

		$ad=html5_2_ad($ad_html);
		$ad['type']='HTML5_2';

	}  else return false;

	$ad['fulltext']=mb_strtolower($ad['fulltext'], 'UTF-8');

	unset($dom);

	$croped=false;
	if(strlen($ad['body'])>=100)	{
		$ad['body']=mb_substr($ad['body'], 0, 100);
		$croped=true;
	}
	if(strlen($ad['header1'])>=40) {
		$ad['header1']=mb_substr($ad['header1'], 0, 40);
		$croped=true;
	}
	if(strlen($ad['header2'])>=40) {
		$ad['header2']=mb_substr($ad['header2'], 0, 40);
		$croped=true;
	}
	if($croped)
		$ad['fulltext']=mb_strtolower($ad['header1'].' '.$ad['header2'].' '.$ad['body'].' '.$ad['displayUrl'], 'UTF-8');

	return $ad;

} else
	return false;

}


/**
 **
**/

function load_single_html_ad ($url) {

	$ad_html=curl_get($url, $GLOBALS['arc_tab_req_string'], '');

	$list=explode('</head>', $ad_html, 2);
	$ad_html=$list[1];
	unset($list, $html);

	$dom = new DOMDocument('1.0', 'UTF-8');
	@$dom->loadHTML($ad_html);

	foreach($dom->getElementsByTagName('script') as $index => $script_node)
		$script_node->parentNode->removeChild($script_node);

	foreach($dom->getElementsByTagName('script') as $index => $script_node)
		$script_node->parentNode->removeChild($script_node);

	foreach($dom->getElementsByTagName('script') as $index => $script_node)
		$script_node->parentNode->removeChild($script_node);

	foreach($dom->getElementsByTagName('style') as $index => $script_node)
		$script_node->parentNode->removeChild($script_node);

	foreach($dom->getElementsByTagName('style') as $index => $script_node)
		$script_node->parentNode->removeChild($script_node);

	unset($ad_html);
	if(trim($dom->textContent))	{
		//$ad['fulltext']=$dom->textContent;

		foreach($dom->getElementsByTagName('div') as $div_node)	{

			if(mb_stripos($div_node->getAttribute('data-type'), 'headline')!==false)	$ad['header1']=$div_node->textContent;
			if(mb_stripos($div_node->getAttribute('data-type'), 'description')!==false)	$ad['body']=$div_node->textContent;

		}
		//if(!$ad['header1'])		$ad['header1']='HTML5 ad';
		if(!$ad['body'])		$ad['body']=$dom->textContent;

		$fulltext=implode(' ',$ad);
		$ad['fulltext']=$fulltext;

		if(!isset($GLOBALS['set_gl']['utf8_off']))
			foreach($ad as $index => $value)
				$ad[$index]=utf8_decode($value);

		return $ad;
	} else
		return false;
}


/**
 **
**/


function html5_2_ad ($html) {

	$list=explode('previewservice.insertPreviewHtmlUrl(', $html, 2);
	$ad_js=$list[1];
	unset($list, $html);

	$list=explode("',", $ad_js);
	unset($ad_js);
	foreach($list as $value)	{

		$value=trim($value, "' ");
		if(mb_stripos($value, 'http')!==false) {
			$url=$value;
			break;
		}
	}

	$ad=load_single_html_ad($url);

	return $ad;
}


/**
 **
**/


function html5_1_ad ($html) {

	$list=explode('var adData = {', $html, 2);
	$ad_js=$list[1];
	unset($list, $html);

	$list=explode('};</script>', $ad_js, 2);
	$ad_js=$list[0];
	unset($list);

	$ad_js=str_replace('[{', "',", $ad_js);

	$list=explode("',", $ad_js);
	unset($ad_js);
	foreach($list as $value)	{
		$string=explode(":", $value, 2);
		$index=trim($string[0], "[{}]' ");
		$value=trim($string[1], "[{}]' ");
		$ad_data[$index]=$value;
	}

	if(@$ad_data['Custom_layout'])	{

		$ad=load_single_html_ad($ad_data['Custom_layout']);

	} else {
		$ad['header1']='';
		$ad['header2']='';
		$ad['body']='';
		$ad['displayUrl']='';
		foreach($ad_data as $index => $value)	{

			if(mb_stripos($index, '_name')!==false)	if($value) $ad['header1'].=$value." ";

			if(mb_stripos($index, 'Headline_')!==false)	{
				if(mb_stripos($index, '_txt')!==false)	if($value)	$ad['header2'].=$value." ";
				if(mb_stripos($index, '_cta')!==false)	if($value)	$ad['displayUrl'].=$value." ";
			}

			if(mb_stripos($index, 'CUSTOM_TEXT')!==false)	{
				if(preg_match('/text$/iu', $index))	{
					if		(mb_stripos($index, '0')!==false)	{ if($value) $ad['header1'].=$value." "; }
					elseif	(mb_stripos($index, '1')!==false)	{ if($value) $ad['header2'].=$value." "; }
					else										{ if($value) $ad['body'].=$value." "; }
				}
			}

			if(mb_stripos($index, 'CUSTOM_BUTTON')!==false)	{
				if(preg_match('/text$/iu', $index))	{ if($value) $ad['displayUrl'].=$value." "; }
			}

			if(mb_stripos($index, '_description')!==false)	if($value)	$ad['body'].=$value." ";
		}
	$fulltext=implode(' ',$ad);
	//$ad['fulltext']=str_replace('<br />', '', $fulltext);
	}
return $ad;
}

/**
 **
**/


function multimedia_ad15 ($html) {

$list=explode('</head>', $html, 2);
$ad_html=$list[1];
unset($list, $html);

$dom = new DOMDocument('1.0', 'UTF-8');
@$dom->loadHTML($ad_html);
unset($ad_html);

$ad['body']='';
foreach ($dom->getElementsByTagName('div') as $div_node) {
	//if( $div_node->getAttribute('class')=='rh' ) $ad['fulltext']=$div_node->textContent;
	if( stripos($div_node->getAttribute('class'), 'ads_')!==false ) $ad['body'].=$div_node->textContent.' ';
}

$ad['header1']='';
$ad['header2']='';
foreach ($dom->getElementsByTagName('a') as $a_node) {
	if( stripos($a_node->getAttribute('class'), 'rhtitle')!==false ) {
		$ad['header1'].=$a_node->textContent.' ';
		$ad['header2'].=$a_node->getAttribute('title').' ';
	}
}

$fulltext=implode(' ',$ad);
$ad['fulltext']=$fulltext;

if(!isset($GLOBALS['set_gl']['utf8_off']))
	foreach($ad as $index => $value)
		$ad[$index]=utf8_decode($value);

return $ad;
}

/**
 **
**/


function multimedia_ad25_26 ($html) {

$list=explode('</head>', $html, 2);
$ad_html=$list[1];
unset($list, $html);

$dom = new DOMDocument('1.0', 'UTF-8');
@$dom->loadHTML($ad_html);
unset($ad_html);
/*
foreach ($dom->getElementsByTagName('div') as $div_node) {
	if( $div_node->getAttribute('class')=='rh' ) $ad['fulltext']=$div_node->textContent;
}*/

foreach ($dom->getElementsByTagName('span') as $span_node) {
	if( stripos($span_node->getAttribute('class'), 'rhbody')!==false ) $ad['body']=$span_node->textContent;
	if( stripos($span_node->getAttribute('class'), 'rhtitle')!==false ) $ad['header1']=$span_node->textContent;
	if( stripos($span_node->getAttribute('class'), 'rhpromotext')!==false ) $ad['header1']=$span_node->textContent;
}

foreach ($dom->getElementsByTagName('a') as $a_node) {
	if( stripos($a_node->getAttribute('class'), 'rhbutton ')!==false ) $ad['displayUrl']=$a_node->textContent;
}

$fulltext=implode(' ',$ad);
$ad['fulltext']=$fulltext;

if(!isset($GLOBALS['set_gl']['utf8_off']))
	foreach($ad as $index => $value)
		$ad[$index]=utf8_decode($value);

return $ad;
}

/**
 **
**/


function text_ad ($html) {

$list=explode('</head>', $html, 2);
$ad_html=$list[1];
unset($list, $html);

$dom = new DOMDocument('1.0', 'UTF-8');
@$dom->loadHTML($ad_html);
unset($ad_html);

foreach ($dom->getElementsByTagName('a') as $a_node) {
	//if( stripos($a_node->getAttribute('class'), 'rhbackground')!==false ) $ad['fulltext']=$a_node->textContent;
	if( stripos($a_node->getAttribute('class'), 'rhtitleline1')!==false ) $ad['header1']=$a_node->textContent;
	if( stripos($a_node->getAttribute('class'), 'rhtitleline2')!==false ) $ad['header2']=$a_node->textContent;
	if( stripos($a_node->getAttribute('class'), 'rhbody')!==false ) $ad['body']=$a_node->textContent;
	//Old ads (with just 1 header) support
	if( stripos($a_node->getAttribute('class'), 'rhtitle ')!==false || stripos($a_node->getAttribute('class'), 'rhtitle"')!==false ) $ad['header1']=$a_node->textContent;
	if( stripos($a_node->getAttribute('class'), 'rhurl ')!==false || stripos($a_node->getAttribute('class'), 'rhurl"')!==false ) $ad['displayUrl']=$a_node->textContent;
}

$fulltext=implode(' ',$ad);
$ad['fulltext']=$fulltext;

if(!isset($GLOBALS['set_gl']['utf8_off']))
	foreach($ad as $index => $value)
		$ad[$index]=utf8_decode($value);

return $ad;
}

/**
 **
**/


function multiformat_ad ($html) {

	$list=explode('var serverAdData = ', $html, 2);
	$ad_json=$list[1];
	unset($list, $html);

	$list=explode(';window.ExitApi =', $ad_json, 2);
	$ad_json=$list[0];
	unset($list);

	$ad_json=str_replace('\\\\', '\\', $ad_json);

	$ad_obj=json_decode($ad_json);

	$ad_data=$ad_obj->google_template_data->adData[0];

	$ad['header1']=$ad_data->text1TFText;
	$ad['body']=$ad_data->text2TFText;
	$ad['displayUrl']=$ad_data->displayUrl;
	if(!$ad['displayUrl']) $ad['displayUrl']=$ad_data->clickTFText;
	$fulltext=implode(' ', $ad);
	$ad['fulltext']=$fulltext.' '.$ad_data->clickTFText.' '.$ad_data->advertiser_name;

	return $ad;
}


/**
 **
**/



function get_stats ($ad_id) {

	$inner_params='[{"1":"'.$ad_id.'"}]';
	$params='{"1":'.$inner_params.'}';

	$result=creative_review ('getApprovalStats', $params);
	unset($inner_params, $params, $key);

	$result=$result->result->{1};
	$result=$result[0]->{3};
	$result=array_sum($result);
	return $result;
}


/**
 **
**/


function get_advertisers_list () {		// function for get list of all blocked AdWords acconuts.

	$params='{"1":"ca-'.$GLOBALS['pub_id'].'"}';
	
	if(isset($GLOBALS['set_gl']['arc5'])) unset($GLOBALS['set_gl']['arc5']);
	
	$result=creative_review ('getAdWordsAdvertiserDecisions', $params);
	unset($params);
	return $result;
}


/**
 **
**/


function unblock_adwords_account ($adv_id) {		// unblock AdWords account function

	if($unblock) $mean_digit='0'; else $mean_digit='1';

	$inner_params='[{"1":"'.$adv_id.'"}]';
	$params='{"1":'.$inner_params.'}';

	$result=creative_review ('removeAdWordsAdvertiserDecisions', $params);

	unset($inner_params,$params);
	return $result;
}


/**
 **
**/


function block_adwords_account ($adv_id) {		// block AdWords account function

	if($unblock) $mean_digit='0'; else $mean_digit='1';

	$inner_params='[{"1":{"1":"'.$adv_id.'"},"2":1}]';
	$params='{"2":'.$inner_params.'}';

	$result=creative_review ('setAdWordsAdvertiserDecisions', $params);
	unset($inner_params,$params);
	return $result;
}

/**
 **
**/


function block_ad ($ad_id, $key, $unblock=0) {		// block and unblock function

	if($unblock) $mean_digit='0'; else $mean_digit='1';

	$inner_params='[{"1":{"1":"'.$ad_id.'"},"2":'.$mean_digit.'}]';  // parameter "2": 1 mean block, 0 mean unblock
	$params='{"1":'.$inner_params.',"2":"'.$key.'"}';

	$result=creative_review ('setCreativeDecisions', $params);
	unset($inner_params, $params, $key);
	return $result;
}


/**
 * 
 * {"1":[{"1":{"1":"AJcDBnsb6goznYNYi45xX/O1dgvPmE5FUFkUj6CzDpefgFuaR9J1lu0S5TqmzUHOpepqhKbX/NXHaNJYxnIDS7+Vzm4Z0omAx7cRRjzO"},"2":1}],"2":"8799266835175170222"}
 * 
 * 
 **
**/


function block_ad_account ($ad_id, $unblock=0) {		// block and unblock function

	if($unblock) {
		$mean_digit='0';
	} else  {
		$mean_digit='1';
	}

	$inner_params='[{"1":{"1":"'.$ad_id.'"},"2":'.$mean_digit.'}]';  // parameter "2": 1 mean block, 0 mean should unblock
	$params='{"2":'.$inner_params.'}';

	$result=creative_review ('setAdWordsAdvertiserDecisions', $params);
	unset($inner_params,$params);
	return $result;
}


/**
 **
**/


function list_ad ($ad, $ad_index, $found) {
$nl="\n";
	if(isset($ad['header2']))			$header2='<br /><span>'.$ad['header2'].'</span>';
	else								$header2='';

	if(isset($ad['header1'])||$header2)	$header='<h2>'.$ad['header1'].$header2.'</h2>'.$nl;
	else								$header='';

	if(isset($ad['stopword']))			$stopword='<span class="stopword" >Blocked by: '.$ad['stopword'].'</span>';
	else								$stopword='';


	if(!$ad['displayUrl']) $ad['displayUrl']=$ad['url_displayed'];
	if(!$ad['displayUrl']) $ad['displayUrl']=parse_url($ad['url'], PHP_URL_HOST );

	$url='<p class="displayurl"><a href="http://nullrefer.com/?'.$ad['url'].'" target="_blank" rel="noreferrer" >'.$ad['displayUrl'].'</a> ('.$ad['type'].')</p>'.$nl;

	$filename=time().'.'.$ad_index;

	$ad_id=rawurlencode($ad['ad_id']);
	$digikey=rawurlencode($ad['digikey']);

	$whitelist_ad='';
	if($ad['header1']) $whitelist_ad.=mb_strtolower($ad['header1'], 'UTF-8')."\n";
	if($ad['header2']) $whitelist_ad.=mb_strtolower($ad['header2'], 'UTF-8')."\n";
	if($ad['body']) $whitelist_ad.=mb_strtolower($ad['body'], 'UTF-8')."\n";
	//if($ad['displayUrl']) $whitelist_ad.=mb_strtolower($ad['displayUrl'], 'UTF-8');
	$whitelist_ad='<a href="whitelist_ad.php?new_ad='.rawurlencode($whitelist_ad).'" onclick="insert_result_frame(this);" target="result_frame" rel="noreferrer" class="whitelist_ad" title="Whitelist this ad" ><img src="img/whl.png" /></a>';

	if($found) {
		if($GLOBALS['set_gl']['get_stats']) $stats='<span class="stats" title="Total views">'.get_stats($ad['ad_id']).'</span>'; else $stats='';
	} else $stats='';

	$block='<a onclick="insert_result_frame(this);" href="blocker.php?type=ad&act=block&ad_id='.$ad_id.'&digikey='.$digikey.'" target="result_frame" class="block block_ad" title="Block this ad" ><img src="img/block.png" />Ad</a>
	<a onclick="insert_result_frame(this);" href="blocker.php?type=ad&act=unblock&ad_id='.$ad_id.'&digikey='.$digikey.'" target="result_frame" class="unblock unblock_ad" title="Unblock this ad" ><img src="img/unblock.png" />Ad</a> ';

	$block_account='<a onclick="insert_result_frame(this);" href="blocker.php?type=acc&act=block&ad_id='.$ad_id.'" target="result_frame" class="block block_acc" title="Block AdWords account" ><img src="img/block.png" />Acc</a>
	<a onclick="insert_result_frame(this);" href="blocker.php?type=acc&act=unblock&ad_id='.$ad_id.'" target="result_frame" class="unblock unblock_acc" title="Unblock AdWords account" ><img src="img/unblock.png" />Acc</a> ';


	$ad_header='<div class="ad_header"><span class="adv_id">'.$ad['adv_name'].' '.$ad['adv_id'].'</span> '.$stopword.'</div>'.$nl;
	//title="'.$ad['fulltext'].'"
	$text='<div class="ad">'.$nl.$whitelist_ad.$nl.$ad_header.$header.'<p class="body">'.$ad['body'].'</p>'.$nl.$url.'</div><span class="block_buttons">'.$block.$block_account.$stats.'</span>'.$nl.$nl.$nl;


	if($found) {
		foreach($found as $index=>$value) {
			if($value) {
				if(!file_exists($GLOBALS['temp_folder'].$index)) mkdir($GLOBALS['temp_folder'].$index, 0775);
				file_put_contents($GLOBALS['temp_folder'].$index.'/'.$filename, $text, FILE_APPEND);
				file_put_contents($GLOBALS['temp_folder'].'autoblocked_accs/'.$ad['adv_id'], $ad['ad_id']);
			}
		}
	} else {
		if(!file_exists($GLOBALS['temp_folder'].'clear')) mkdir($GLOBALS['temp_folder'].'clear', 0775);
		file_put_contents($GLOBALS['temp_folder'].'clear/'.$filename, $text, FILE_APPEND);

	}

return true;
}


/**
 **
**/


function is_ad_whitelisted ($ad_fulltext) {

	$whitelisted=false;
	if(isset($GLOBALS['set_gl']['whitelist'])) {

		$whitelist=file($GLOBALS['settings_folder'].'whitelist.txt', FILE_IGNORE_NEW_LINES);

		foreach($whitelist as $whitestring)	{
			if($whitestring)
				if(mb_stripos($ad_fulltext, $whitestring)!==false) {		//if we can find any  word
					$whitelisted=true;
					break;
				}
		}
	}
	return $whitelisted;
}


/**
 **
**/



function mark_ads_reviewed ($ad_id) {

	foreach($ad_id as $id)
		$ids[]='{"1":"'.$id.'"}';
	unset($ad_id);

	if(isset($GLOBALS['set_gl']['arc5']))	$append=',"2":0';
	else 									$append='';

	$params='{"1":['.implode(',',$ids).']'.$append.'}';
	$result=creative_review ('setReviewedCreatives', $params);
	unset($params);

	return $result;
}


/**
 **
**/


function creative_review ($method, $params) {
	
	if(isset($GLOBALS['set_gl']['arc5'])) return creative_review_new (ucfirst($method), $params);

	$xsrftoken=file_get_contents($GLOBALS['xsrftoken_file']);

	$creativeReview = new stdClass(); //to make json request string
	$creativeReview->method=$method;
	$creativeReview->params=$params;
	$creativeReview->xsrf=$xsrftoken;
	$creativeReview_post_request=json_encode($creativeReview);
	unset($creativeReview);

	$result=curl_post($GLOBALS['creative_review_req_string'], $creativeReview_post_request, $GLOBALS['arc_tab_req_string'], $GLOBALS['myheaders']);

/*	if(stripos($result, 'XSRF token validation')!==false) {
		file_put_contents($GLOBALS['temp_folder'].'creative_review/err.'.time(), $method.' /// '.$result, FILE_APPEND);
	}	*/																										//temp

	if(isset($GLOBALS['set_gl']['log'])) file_put_contents($GLOBALS['temp_folder'].'logs/s3.'.$method.'.'.time(), $result);

	$result=json_decode($result);  // decode result string
	
	if($result->xsrf)
		file_put_contents($GLOBALS['xsrftoken_file'], $result->xsrf); // Renew standard XSRF token

	return $result;
}

/**
 **
**/



function creative_review_new ($method, $params) {

	$xsrftoken=file_get_contents($GLOBALS['temp_folder'].'xsrftoken_new.txt');

	$myheaders=$GLOBALS['myheaders_new'];
	$myheaders[]='x-framework-xsrf-token:'.$xsrftoken;

	$query['pc']='ca-'.$GLOBALS['pub_id'];
	$query['onearcClient']='adsense';
	$query['hl']='en_US';

	foreach($query as $index => $value)
		$rpc[]=$index.'='.$value;
		
	$append=':1';
	$query['rpcTrackingId']=$GLOBALS['creative_review_new_string'].$method.'?'.implode('&', $rpc).$append;
	$query=http_build_query($query);
	$url='https://www.google.com'.$GLOBALS['creative_review_new_string'].$method.'?'.$query;
	$result=curl_post($url, $params, $GLOBALS['arc_tab_req_string'], $myheaders);

	if(isset($GLOBALS['set_gl']['log'])) file_put_contents($GLOBALS['temp_folder'].'logs/s3_new.'.$method.'.'.time(), $result);

	$list=explode("\n", $result, 2);
	$result=$list[1];
	
	$result=json_decode($result);  // decode result string
	
	if($result->default->{5})
		file_put_contents($GLOBALS['temp_folder'].'some_digi_token.txt', $result->default->{5}); // Renew token
	if($result->default->{6})	
		file_put_contents($GLOBALS['temp_folder'].'some_long_token.txt', $result->default->{6}); // Renew token

	return $result;
}


/**
 **
**/

function get_ad_list ($folder) {
	if($folder=='blogspot'||$folder=='clear'||$folder=='redirect'||$folder=='word'||$folder=='disguised') {
		if(!file_exists($GLOBALS['temp_folder'].$folder)) mkdir($GLOBALS['temp_folder'].$folder, 0775);
		$ad_files=scandir($GLOBALS['temp_folder'].$folder);
		unset($ad_files[0],$ad_files[1]);	//removes . and ..

		$ads_text='';
		foreach($ad_files as $ad_file) {

			$time=explode('.',$ad_file);
			$time='<span title="When was checked" class="date_time">'.date("d.m.Y", $time[0]).'<br>'.date("H:i:s", $time[0]).'</span>';
			$trash='<a title="Delete this ad" class="trash" onclick="close_ad(this);" href="delete.php?folder='.$folder.'&ad_file='.rawurlencode($ad_file).'" target="working_frame"><img src="img/trash.gif" /></a>';
			$ads_text.='<div class="ad_container" >'.file_get_contents($GLOBALS['temp_folder'].$folder.'/'.$ad_file).$time.$trash.'</div>';
		}

	return $ads_text;
	}
}


/**
 **
**/


function remove_ad_files ($folder, $ad_file) {
	if($folder=='blogspot'||$folder=='clear'||$folder=='redirect'||$folder=='word'||$folder=='disguised') {
		if($ad_file){
			if(preg_match ('/^\d{10,11}\.\d{1,3}$/', $ad_file))
				$result=unlink ($GLOBALS['temp_folder'].$folder.'/'.$ad_file);
		}
		else {
			$ad_files=scandir($GLOBALS['temp_folder'].$folder);
			unset($ad_files[0],$ad_files[1]);	//removes . and ..
			foreach($ad_files as $ad_file) {
				$result=unlink ($GLOBALS['temp_folder'].$folder.'/'.$ad_file);
				if(!$result) $break;
			}
		}

	return $result;
	}
}


/**
 **
**/



function unblock_old_accounts($age) {

	$acc_files=scandir($GLOBALS['temp_folder'].'autoblocked_accs');

	$count=0;
	foreach($acc_files as $acc_file) {
		if($acc_file!='.'&&$acc_file!='..') {
			$acc_age=time()-filemtime ($GLOBALS['temp_folder'].'autoblocked_accs/'.$acc_file);
			$acc_age=$acc_age/3600/24;
			if($acc_age>$age) {
				unblock_adwords_account(file_get_contents($GLOBALS['temp_folder'].'autoblocked_accs/'.$acc_file));
				unlink($GLOBALS['temp_folder'].'autoblocked_accs/'.$acc_file);
				$count++;
			}
		}
	}
	if($count==0) $count='';
	return $count;
}



/**
 **
**/



function is_still_log_in() {
	$cookies=file_get_contents($GLOBALS['cookie_file']);
	if(stripos($cookies, 'SIDCC')!==false) 	return true;
	else 									return false;
}



/**
 **
**/


function get_paid_stats ($html) {
	$list=explode('bruschettaMetadata = \'', $html, 2);
	$script_with=$list[1];
	$list=explode('\'; ', $script_with, 2);
	$script_with=$list[0];
	$res=json_decode($script_with);
	return $res;
}

