<?php
include_once 'functions.php';

if(!is_still_log_in())	{
    die('You should log in to Google first');
}

$url='https://www.google.com/adsense/gwt-properties?pid='.$GLOBALS['pub_id'].'&authuser=0&tpid='.$GLOBALS['pub_id'].'&ov=3';

$result=curl_post($url, '', $GLOBALS['arc_tab_req_string'], $GLOBALS['myheaders']); // Requesting access tokens in meta tags
unset($url);
$gwtarray=metagwt2array($result); // Converting data to array

file_put_contents($GLOBALS['xsrftoken_file'], $gwtarray['syn_token_pb']); // Put XSRF new token

	/**
	— * Get temporary access tokens:
	**/


for($i=0;$i<$set['num_of_pages'];$i++) {

		$params = new stdClass();
		@$params->{1}='ca-'.$GLOBALS['pub_id'];
		$params=json_encode($params);

	$result=creative_review ('getWebPropertyMetricsToken', $params);
	unset($params);

	/**
	 * Get ads list:
	**/

	if(isset($set['text'])) $type['text']='0';
	if(isset($set['rich_media'])) $type['media']='2';
	$media_types='['.implode(',',$type).']';

		$params = new stdClass();
		@$params->{1}='ca-'.$GLOBALS['pub_id'];  // Publisher Id ca-pub-...
			@$params->{2}->{1}=$start_pos+$i*$set['num_of_ads_per_page'];							// Start position
			@$params->{2}->{2}=$set['num_of_ads_per_page'];	// Ads qty
			@$params->{2}->{3}=1;							// 0 - Shown ads; 1 - already blocked ads
			@$params->{2}->{5}->{16}=$media_types;			// 0 - Text; 1 - graphics; 2 - Media; If checked all types the parameter is absent.
			if(!isset($set['rich_media'])) @$params->{2}->{5}->{17}=0;			//Disappears at turning on media type
		//$params->{3}='-6928690776790362';

		$params=json_encode($params);
		$params=str_replace('"[', '[', $params);
		$params=str_replace(']"', ']', $params);

	$result=creative_review ('searchArcApprovals', $params);

	$digikey_for_req=$result->result->{5}; // Some digits required to control requests.

	foreach($result->result->{1} as $key=>$node) {
		$ad_id[$key]=$node->{4}->{1}; // Some sequence required to control requests of each ad
		//$ad_req_urls[$key]=$node->{5}->{10}; // url we can access ad sourse code
		$ad_req_urls=$node->{5}->{10}; // url we can access ad sourse code
		$ad[$key]=get_ad($ad_req_urls);	//Indexes of returned array: fulltext, header1, header2, body, url
		unset($ad[$key]['url']);
		set_time_limit(30);		//Renew time limit for each ad download
	}

	unset($result,$ad_req_urls);

	foreach($ad as $ad_unit) {
		$ad_long[]=$ad_unit;
	}

}


foreach($ad_long as $index=>$ad) {

	$body=trim($ad['body']);
	$str_len=mb_strlen($body);

	if($str_len>47) {
		$half_len=round($str_len/2, 0, PHP_ROUND_HALF_UP);
		$body1=mb_substr($ad['body'], 0, $half_len).$nl;
		$body2=mb_substr($ad['body'], $half_len);
	} else {
		$body1=$ad['body'].$nl;
		$body2='';
	}

	$text=$ad['header1'].$nl.$ad['header2'].$nl.$body1.$body2;
	$ad_arr[]=mb_strtolower($text, 'UTF-8');
}

$prev=file($GLOBALS['settings_folder'].'bad_ads_text.txt', FILE_IGNORE_NEW_LINES);
foreach($prev as $text) {
	$ad_arr[]=$text;
}


$ad_arr=array_unique($ad_arr);

asort($ad_arr);

$out_file='';
$out='';
foreach($ad_arr as $text) {
	$text=trim($text);
	$text=trim($text, '?,.:');
	if($text) {
		$out_file.=$text.$nl;
		$out.=$text.'<br />'.$nl;
	}

}

file_put_contents($GLOBALS['settings_folder'].'bad_ads_text', $out_file);

if(!isset($meta_continue)) 	$meta_continue='';
if(!isset($a_continue)) $a_continue='';
if(!isset($cycle_report)) $cycle_report='';
else 						$out='';

?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="referrer" content="same-origin" />
<meta name="robots" content="noindex, nofollow" />
<link href="img/favicon.ico" rel="shortcut icon" type="image/x-icon" />
<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=4, minimum-scale=0.1" />
<?=$meta_continue?>
<style>
* { font-size: 16px;  font-family: Calibri, Verdana, Arial; }
body { background: #fff; }
</style>
</head>
<body>

<?=$out?>

<?=$cycle_report?>
<?=$a_continue?>


</body>
</html>